precision mediump float;
varying vec2 v_texCoord;
varying vec4 v_position;
uniform sampler2D sTexture;
uniform vec4 u_color;
uniform vec2 u_center;
uniform float u_radius;
uniform float u_scale;
void main() {
    vec4 textureColor = texture2D(sTexture, v_texCoord);
    float dist = distance(u_center.xy,v_position.xy);
    float circleAlpha = 1. - smoothstep(0.,u_scale,dist - u_radius);
    gl_FragColor = u_color * textureColor.a * circleAlpha;
}