precision mediump float;

attribute vec2 a_texCoord;
attribute vec4 a_position;
varying vec2 v_texCoord;

varying vec2 v_tcLeftBall;
varying vec2 v_tcRightBall;

varying vec4 v_color;

uniform mat4 MATRIX_MVP;
uniform float u_scale;
uniform vec2 u_resolution;
const vec2 gridsize = vec2(23. * 0.7 * 2.5, 40. * 0.7);

const int MAX_NUM_OF_TAPS = 10;
uniform vec3 u_touches[MAX_NUM_OF_TAPS];


uniform vec4 u_time;

varying vec2 v_position;


const float duration = 0.7;  // was 1.
const float offset = 0.1;
const float offsetFr = offset / duration;   // was 0.1

const float WIDTH_NORMAL_SQ = 20000.;      // 600. square
const float RIPPLE_SPEED = 12.;     // was 52.

//vec4 col1 = vec4(254./255., 241./255., 251./255., 1.);
//vec4 col2 = vec4(225./255., 248./255., 254./255., 1.);

vec4 col1 = vec4(255./255., 227./255., 241./255., 1.);
vec4 col2 = vec4(214./255., 245./255., 254./255., 1.);
// vec4 col1t2 = vec4(223./255.,237./255.,254./255., 1.);
vec4 col1t2 = vec4(1.);



const float M_PI = 3.1415926535897932384;
const float M_PI_2 = 1.57079632679;

const float WAVE_SPEED = 0.5;

void main() {
    vec2 tc = a_texCoord;
    v_texCoord = tc;
    

    // v_position = a_position.xy;
    
    vec4 pos = a_position;
    gl_Position = MATRIX_MVP * pos;
    
//     float sn = snoise(vec3(tc * 1.35, u_time.x)) * 0.5 + 0.5;
    
//     sn *= 2.;
    
// //    vec4 col = mix(col1, col2, sn);
//     vec4 col = mix(col1, col1t2, min(sn, 1.));
//     col = mix(col, col2, max(sn - 1., 0.));
    
    /*
    float sinTime = sin(u_time.x * 7.) * 0.5 + 0.5;
    float sinTime2 = sin(u_time.x * 3.5) * 0.5 + 0.5;
    
    float scaleLeft = 0.6 + sinTime * 0.8;
    float scaleRight = 0.6 + (1. - sinTime) * 0.8;
    
    vec2 tcLeft = vec2(tc.x + 0.2 - 0.4 * sinTime, 1. - tc.y);
    tcLeft *= scaleLeft;    
    v_tcLeftBall = tcLeft;
    
    vec2 tcRight = vec2(1. - tc.x + 0.17 - 0.4 * sinTime, tc.y);
    tcRight *= scaleRight;
    v_tcRightBall = tcRight;

    */

    float sinTime = sin(u_time.x * 5.);
    float sinTime2 = sin(u_time.x * 5. + M_PI_2);

    vec2 mvOffset = vec2(sinTime * 0.3, sinTime2 * 0.2);

    float scaleLeft = 0.75 + sinTime * 0.4;
    float scaleRight = 0.75 - sinTime * 0.4;

    vec2 tcLeft = tc;
    tcLeft -= vec2(0.5);
    tcLeft *= scaleLeft;
    tcLeft += vec2(0.5);
    tcLeft += mvOffset;
    v_tcLeftBall = tcLeft;

    vec2 tcRight = tc;
    tcRight -= vec2(0.5);
    tcRight *= scaleRight;
    tcRight += vec2(0.5);
    tcRight -= mvOffset;
    v_tcRightBall = tcRight;


    
//    v_color = col;
    v_color = col1t2;
//    v_color = vec4(1.);
//    v_color = vec4(0.5,0.5,0.5, 1.);
}
