precision mediump float;
varying vec2 v_texCoord;
uniform sampler2D sTexture;
uniform float u_alpha;

uniform float iAntiAlias;
uniform float iRadius;
uniform float iStrength;
uniform float iLightX;
uniform float iLightY;


float circle();

void main() {
    float light = circle();
    vec4 high = vec4(0.447,0.874,0.909,1f) * light * light * light * 10.0 * iStrength;
    vec4 base = u_alpha * texture2D(sTexture, v_texCoord);
    vec4 highlight = base * high;
    gl_FragColor = base + highlight;
}

float circle() {
    vec2 p = v_texCoord + vec2(-iLightX,-iLightY);
    float d = length(p)- iRadius ;
    float t1 = smoothstep(0.0,iAntiAlias, d);
    return (1.0-t1);
}
